.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ConvertToASCII  PROTO	:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth         equ             400
MainWindowHeight        equ             300

.data

hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              '???',0

TreeViewClass   db      'SysTreeView32',0
hTreeView        dd                   ?
tvis            TV_INSERTSTRUCT         <>
tvi                     TV_ITEM	      <>

te32            THREADENTRY32           <>
pe32            PROCESSENTRY32        <>
TempBuffer      db      256 dup(0)
NumBuffer       db      8 dup('0'),'H',0
xlat_table         db           '0123456789abcdef',0

.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
                invoke  InitCommonControls
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        pop     ebx
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow
        call      FillControls3
        
        .while  TRUE

                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        local   rect:RECT


        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
        
        .elseif uMsg==WM_CREATE
                mov     edi,lParam
                .if     [edi.CREATESTRUCT].hWndParent==NULL
                        invoke  GetClientRect,hWnd,addr rect
                        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+TVS_HASLINES\
                                +TVS_HASBUTTONS+TVS_LINESATROOT,0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                        mov     hTreeView,eax
                .endif 
        .else                
                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp


FillControls3   PROC

        local   hSnap:DWORD
        
        mov     tvis.hParent,NULL
        mov     tvis.hInsertAfter,TVI_LAST
        mov     tvis.item.imask,TVIF_TEXT+TVIF_PARAM ;+TVIF_IMAGE+TVIF_SELECTEDIMAGE
        push    offset pe32.szExeFile
        pop     tvis.item.pszText
        mov     tvis.item.cchTextMax,256
        mov     tvi.imask,TVIF_HANDLE+TVIF_TEXT+TVIF_PARAM
        mov     tvi.pszText,offset TempBuffer
        mov     tvi.cchTextMax,256
        mov     pe32.dwSize,sizeof pe32
        mov     te32.dwSize,sizeof te32

        invoke  CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS+TH32CS_SNAPTHREAD,NULL
        mov     hSnap,eax
        invoke  Process32First,hSnap,addr pe32
        cmp     eax,FALSE
        je      no_process
@@1:        
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        invoke  Process32Next,hSnap,addr pe32
        cmp     eax,FALSE
        je      no_process
        jmp     @@1
no_process:
        invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_ROOT,NULL
        mov     tvis.item.pszText,offset NumBuffer
               
@@21:
        push    eax
        pop     tvi.hItem
@@2:
        invoke  Thread32First,hSnap,addr te32
        cmp     eax,FALSE
        je      no_thread
        invoke  SendMessage,hTreeView,TVM_GETITEM,NULL,addr tvi
@@3:        
        mov     eax,te32.th32OwnerProcessID
        cmp     eax,tvi.lParam
        je        insert_item
@@31:        
        invoke  Thread32Next,hSnap,addr te32
        cmp     eax,FALSE
        je      no_thread
        jmp     @@3
insert_item:
        push    tvi.hItem
        pop     tvis.hParent
        invoke  ConvertToASCII,te32.th32ThreadID,addr NumBuffer
        push    te32.th32ThreadID
        pop     tvis.item.lParam
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        jmp     @@31
no_thread:
        invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_NEXT,tvi.hItem
        cmp     eax,NULL
        je        ender
        jmp     @@21
ender:
        invoke  CloseHandle,hSnap
        ret         
                
FillControls3   endp

ConvertToASCII  PROC    val:DWORD,lpBuffer:DWORD

               push    eax
               push    ebx
               push    edx
               push    ecx                        
               pushfd  
               cld                                    
               mov     edi,lpBuffer
               push    edi
               mov      eax,'0000'
               stosd
               stosd
               pop     edi                                           
               mov     eax,val
               mov     ebx,010h                        
               add     edi,7
               std
looper:
               xor     edx,edx
               div     ebx
               cmp      eax,0
               je      end_looper
               push    eax
               push    ebx
               mov     al,dl
               lea     ebx,xlat_table
               xlat    
               stosb
               pop     ebx
               pop     eax
               jmp     looper
end_looper:
               mov     al,dl
               lea     ebx,xlat_table
               xlat
               stosb
               popfd
               pop     ecx
               pop     edx
               pop     ebx
               pop     eax                                                                                                
               ret

ConvertToASCII  endp

end     start                                       